--
-- s_netmon.lua
--

local running = false -- if race is running

addEventHandler( "onResourceStart", root,
	function()
		logToFile( "netmon started" )
		setTimer( pulse, 1000, 0 )
	end
)

addEventHandler( "onResourceStop", root,
	function()
		logToFile( "netmon stopped" )
	end
)

addEventHandler( "onPlayerJoin", root,
	function()
		local status = string.format( "+++ onPlayerJoin: %s  (Total plrs:%d)"
						,getPlayerName(source)
						,getPlayerCount()
						)
		logToFile( status )
	end
)

addEventHandler( "onPlayerQuit", root,
	function(quitType)
		local status = string.format( "--- onPlayerQuit: %s (%s) (Total plrs:%d)"
						,getPlayerName(source)
						,quitType
						,getPlayerCount() - 1
						)
		logToFile( status )
	end
)


function pulse()
	local n = getNetworkStats()
	if oldStats then
		local status = string.format( "pktsRecv:%d  pktsSent:%d"
						,math.max(0,n.packetsReceived - oldStats.packetsReceived)
						,math.max(0,n.packetsSent - oldStats.packetsSent)
						)
		logToFile( status )
	end
	oldStats = n
end

function logToFile( msg )
	local t = getRealTime()
	local logFileName = string.format("logs/%04d-%02d-%02d_%02d-%02d-%02d"
					,t.year + 1900 
					,t.month + 1 
					,t.monthday 
					,t.hour
					,0
					,0
					)
	local logMsg = string.format("%04d-%02d-%02d %02d:%02d:%02d - %s"
					,t.year + 1900 
					,t.month + 1 
					,t.monthday 
					,t.hour
					,t.minute 
					,t.second 
					,msg
					)
	---outputDebugString(logMsg)
	local fh = fileExists( logFileName ) and fileOpen( logFileName ) or fileCreate( logFileName )
	if fh then
		fileSetPos( fh, fileGetSize( fh ) ) 
		fileWrite( fh, logMsg .. "\n" )
		fileClose( fh )
	end
end
